/*****************************************************************************
* PELICAN crossing example
*
* Copyright (c) 2006 Miro Samek. All rights reserved.
*
* Email: miro@quantum-leaps.com
* Web:   www.quantum-leaps.com
*****************************************************************************/
#include "qpn_port.h"                                       /* QP-nano port */
#include "bsp.h"                             /* Board Support Package (BSP) */
#include "pelican.h"                               /* application interface */

/*..........................................................................*/
static Pelican l_pelican;
static QEvent  l_pelicanQueue[1];

static Ped     l_ped;

/*..........................................................................*/
/* CAUTION: the QF_active[] array must be initialized consistently with
* the priority assignement in pelican.h
*/
QActiveCB const Q_ROM QF_active[] = {
    { (QActive *)0,          (QEvent *)0,    0                     },
    { (QActive *)&l_pelican, l_pelicanQueue, Q_DIM(l_pelicanQueue) },
    { (QActive *)&l_ped,     (QEvent *)0,    0                     }
};
uint8_t const Q_ROM QF_activeNum = Q_DIM(QF_active) - 1;

/*..........................................................................*/
void main (void) {
    BSP_init();                                     /* initialize the board */

    Pelican_init(&l_pelican);
    Ped_init(&l_ped, 15);           /* init Ped, set # PED_WAITING attempts */

    QF_run();                                /* transfer control to QF-nano */
}
