/*****************************************************************************
* PELICAN crossing example
*
* Copyright (c) 2006 Miro Samek. All rights reserved.
*
* Email: miro@quantum-leaps.com
* Web:   www.quantum-leaps.com
*****************************************************************************/
#ifndef pelican_h
#define pelican_h

enum PelicanSignals {
    PEDS_WAITING_SIG = Q_USER_SIG,
    OFF_SIG,
    ON_SIG
};

enum PelicanPriorities {
    PELICAN_PRIO = 1,
    PED_PRIO
};

/* active objects ..........................................................*/
typedef struct PelicanTag Pelican;
struct PelicanTag {
    QActive super_;                                 /* derived from QActive */
    uint8_t pedFlashCtr__;                      /* pedestrian flash counter */
};
void Pelican_init(Pelican *me);

typedef struct PedTag Ped;
struct PedTag {
    QActive super_;                                 /* derived from QActive */
    uint8_t retry__;
    uint8_t retryCtr__;
};
void Ped_init(Ped *me, uint8_t retry);

#endif                                                         /* pelican_h */
